<?php

namespace Modules\Fm\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Fm\Entities\SupplierInvoiceHeader;
use Modules\St\Entities\Suppliers;

class SupplierInvoiceListController extends Controller
{

    public function allSupplierInvoice()
    {
        try {
            $invoiceList = SupplierInvoiceHeader::where('document_no', '=', '0')->orderBy('internal_id', 'DESC')->get();
            foreach ($invoiceList as $invoice) {
                $supplier = Suppliers::find($invoice->supplier_Id);
                $invoice->supplier = $supplier->supplier_name;
            }
            $responseBody = $this->responseBody(true, "SupplierInvoiceListController", "allSupplierInvoice", $invoiceList);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "SupplierInvoiceListController", "allSupplierInvoice", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }

    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
